/*此数码管采用的是共阴极数码管*/
//设置阳极接口
int a=8;
int b=10;
int c=5;
int d=3;
int e=2;
int f=9;
int g=6;
int dp=4;
//设置阴极接口
int d1=A5;
int d2=A4; 
int d3=A3; 
int d4=A2;
//设置变量
long n=0;
int x=100;
int del=55;
int i=0;
 
byte pos_segs[8] = { a, b, c, d, e, f, g, dp};
//byte neg_segs[4] = { d1, d2, d3, d4 };
byte seven_seg_digits[10][7] = { { 1,1,1,1,1,1,0 },  // = 0
                                 { 0,1,1,0,0,0,0 },  // = 1
                                 { 1,1,0,1,1,0,1 },  // = 2
                                 { 1,1,1,1,0,0,1 },  // = 3
                                 { 0,1,1,0,0,1,1 },  // = 4
                                 { 1,0,1,1,0,1,1 },  // = 5
                                 { 1,0,1,1,1,1,1 },  // = 6
                                 { 1,1,1,0,0,0,0 },  // = 7
                                 { 1,1,1,1,1,1,1 },  // = 8
                                 { 1,1,1,1,0,1,1 }   // = 9
                             }; 

void setup()
{
  pinMode(d1, OUTPUT);
  pinMode(d2, OUTPUT);
  pinMode(d3, OUTPUT);
  pinMode(d4, OUTPUT);
  pinMode(a, OUTPUT);
  pinMode(b, OUTPUT);
  pinMode(c, OUTPUT);
  pinMode(d, OUTPUT);
  pinMode(e, OUTPUT);
  pinMode(f, OUTPUT);
  pinMode(g, OUTPUT);
  pinMode(dp, OUTPUT);
  pinMode(11,OUTPUT);
  pinMode(12,INPUT);
  pinMode(A1,INPUT);
  pinMode(A0,INPUT);
  pinMode(12,INPUT);
  pinMode(7,INPUT);
  digitalWrite(11,0 ); 
}
 
void loop()
{
  clearLEDs();
  pickDigit(1);
  lightSegments((n/x/1000)%10);
  delayMicroseconds(del);
 
  clearLEDs();
  pickDigit(2);
  lightSegments((n/x/100)%10);
  delayMicroseconds(del);
 
  clearLEDs();
  pickDigit(3);
  lightSegments((n/x/10)%10);
  delayMicroseconds(del);
 
  clearLEDs();
  pickDigit(4);
  lightSegments(n/x%10);
  delayMicroseconds(del);
  
  if  (digitalRead(A1)==LOW){      //如果检测到2脚为高电平（按下按键，数据为1）
      delay(200);                          //适当延时跳开抖动
      i++;                                      //变量加1
      if (i>1){                                //如果变量大于1，则置为0
         i=0;
      }
      switch (i) {
         case 0: digitalWrite(11, LOW);break;    //如果i=0, LED熄灭
         case 1: digitalWrite(11, HIGH);break;    //如果i=1, LED点亮
      }
  }
       
   if(digitalRead(7)==HIGH)
     {
       n=n++;
     }
 
  if (digitalRead(12) == LOW)
  {
    n = 0;
  }

}
 
void pickDigit(int x)  //定义pickDigit(x),其作用是开启dx端口
{
  digitalWrite(d1, HIGH);
  digitalWrite(d2, HIGH);
  digitalWrite(d3, HIGH);
  digitalWrite(d4, HIGH);
  
  switch(x)
  {
  case 1: 
    digitalWrite(d1,LOW); 
    break;
  case 2: 
    digitalWrite(d2, LOW); 
    break;
  case 3: 
    digitalWrite(d3, LOW); 
    break;
  default: 
    digitalWrite(d4, LOW); 
    break;
  }
}
 
 
//清屏 
void clearLEDs()  
{
  for (int i = 0; i < 8; i++) 
    digitalWrite(pos_segs[i], LOW);
}
 
 
// 点亮对应数字的数码管
void lightSegments(int x) 
{
  for (int i = 0; i < 7; i++) {
    digitalWrite(pos_segs[i], seven_seg_digits[x][i]);
  }
}

